unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, jpeg, ExtCtrls;

type
  TForm1 = class(TForm)
	Image1: TImage;
	Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
type
	PByteArray3 = ^TByteArray3;
	TByteArray3 = array[0..2] of byte;
	TLogPal = packed record
		palVersion: word;
		palNumEntries: word;
		PalEntry: array[0..255] of LongWord;
	end;
var
	srcBitmap: TBitmap;
	dstBitmap: TBitmap;
	palette: TLogPal;
	i, x, y: integer;
	pSour: PByteArray3;
	pDest: PByte;
	gray: byte;
begin
	//  ̹
	srcBitmap := TBitmap.Create();
	srcBitmap.Assign(Image1.Picture.Graphic);
	srcBitmap.PixelFormat := pf24Bit;

	// 8-bit ̹
	dstBitmap := TBitmap.Create();
	dstBitmap.Assign(srcBitmap);
	dstBitmap.PixelFormat := pf8Bit;

	// palette  
	palette.palVersion := $300;
	palette.palNumEntries := 256;
	for i := 0 to pred(palette.palNumEntries) do begin
		palette.PalEntry[i] := (i shl 16) or (i shl 8) or (i);
	end;

	dstBitmap.Palette := CreatePalette(PLogPalette(@palette)^);

	// gray ȯ
	for y := 0 to pred(srcBitmap.Height) do begin
		pSour := PByteArray3(srcBitmap.ScanLine[y]);
		pDest := PByte(dstBitmap.ScanLine[y]);
		for x := 0 to pred(srcBitmap.Width) do begin
			pDest^ := (pSour[0] * 3 + pSour[1] * 6 + pSour[2] * 1) div 10;
			inc(pSour);
			inc(pDest);
		end;
	end;

	// 
	Canvas.Draw(340, 0, dstBitmap);

	srcBitmap.Free();
	dstBitmap.Free();
end;

end.
